       function finterp(x,xa,ya,n)
       dimension xa(n), ya(n)
* to linearly interpolate for y between two pairs (x,y)
* from the given input arrays. 

       i = 1
       j = i+1
       do while ((j.le.n).and.
     &	  (x.lt.min(xa(i),xa(j)).or.x.gt.max(xa(i),xa(j)))) 
          i = j
          j = i+1
       enddo
       if (j.gt.n) then
          write(6,*) 'Error: ',x,' not in array'
          finterp = 0.
          return
       endif
       abs1 = abs(1.-xa(i)/x)
       abs2 = abs(1.-xa(i-1)/x)
       if (i.gt.1) then
	  if (abs1.lt.1.e-6.and.abs2.lt.1.e-6) then 
             finterp = 0.5*(ya(i) + ya(i-1)) 
             return
          endif
       endif
       abs1 = abs(1.-xa(i)/x)
       abs2 = abs(1.-xa(i+1)/x)
       if (i.lt.n) then
	  if (abs1.lt.1.e-6.and.abs2.lt.1.e-6) then 
             finterp = 0.5*(ya(i) + ya(i+1)) 
             return
	  endif
       endif
       abs1 = abs(1.-xa(j)/x)
       abs2 = abs(1.-xa(j-1)/x)
       if (j.gt.1) then
	  if (abs1.lt.1.e-6.and.abs2.lt.1.e-6) then 
             finterp = 0.5*(ya(j) + ya(j-1)) 
             return
	  endif
       endif
       abs1 = abs(1.-xa(j)/x)
       if (j.lt.n) then
          abs2 = abs(1.-xa(j+1)/x)
	  if (abs1.lt.1.e-6.and.abs2.lt.1.e-6) then 
             finterp = 0.5*(ya(j) + ya(j+1)) 
             return
	  endif
       endif
       x0 = xa(i)
       y0 = ya(i)
       x1 = xa(j)
       y1 = ya(j)
       finterp = (x-x0)*(y1-y0)/(x1-x0) + y0
       return
       end

