      subroutine gettsor(ela,elo,nti,i,f)
      include 'params.h'
* routine to get the three edge points of the triangle enclosing 
* an arbitrary location (ela, elo) in the rotated coordinate 
* system. So, nti is 3, i() are the indices of the nodes, and
* f() the coefficients for linear interpolation.
      parameter(nofclosev=8)
      dimension i(ntri), f(ntri) 
      dimension dmin(nofclosev), i7(nofclosev)
      dimension ka(3000)
      logical nextnode

      cela = cos(ela)
      if (cela.lt.epsilon) cela = epsilon
      nti = ntri
  
      do l=1,nofclosev 
	 dmin(l) = 2*pi 
	 i7(l) = 0 
      enddo

      if (ela.lt.atmin) then
*         write(6,*) 'point outside area, ela = ',ela
         nti = 0
         return
      endif

      nstart = nest(ela,dan,fac)
      nend = nest(ela,-dan,fac)
      dons = don/cela
      ik = 0
      do k=nstart,nend
         elompp = elo - pp(k)
         do while (elompp.gt.pi) 
	    elompp = elompp-twopi
         enddo
         do while (elompp.lt.-pi) 
	    elompp = elompp + twopi
         enddo
         if (abs(elompp).le.dons) then
	    ik = ik+1
	    ka(ik) = k
	 endif
      enddo
      nk = ik

* find a number of closest vertices:
      nl = 0
      do ik = 1,nk 
         call deltas(delta,tt(ka(ik)),pp(ka(ik)),ela,elo)
         if (delta.le.edmx) then
            nl = nl+1
            if (nl.gt.nofclosev) then
	       write(6,*) 'error: nl >',nofclosev,' for ela,elo = ',
     &			   180.*ela/pi,180.*elo/pi
            else
               dmin(nl) = delta      
               i7(nl) = ka(ik)
            endif
         endif 
      enddo
*if (nl < 1) {
*   write(6,*) 'error: nl<=0 for ela,elo = ',180.*ela/pi,180.*elo/pi
*   nti = 0
*   return
*}
      if (nl.lt.3) then
*         write(6,*) 'error: nl<3 for ela,elo = ',180.*ela/pi,180.*elo/pi
         nti = 0
         return
      endif

* now sort the set of closest vertices:
      do l=2,nl 
         do m=1,l-1 
            if (dmin(l).lt.dmin(m)) then
               dmintmp = dmin(l)
               i7tmp = i7(l)
               do j=l,m+1,-1 
                  dmin(j) = dmin(j-1)
                  i7(j) = i7(j-1) 
	       enddo 
               dmin(m) = dmintmp
               i7(m) = i7tmp 
            endif
	 enddo
      enddo

* assume first vertex is right because it is closest,
* for the other two we can't be sure, try a next pair.

      nextnode=.false.
      l1=1 
      l2=2 
      l3=3
      call trids(ds,dd,tt(i7(l2)),pp(i7(l2)),tt(i7(l3)),pp(i7(l3)),
     &		 ela,elo,tt(i7(l1)),pp(i7(l1)))
      if (dd.le.ddmn) then
         nextnode=.true.
      else
         factor = ds/dd
         if (factor.gt.1.) nextnode=.true.
      endif
      do while (nextnode.and.l2.lt.nl-1) 
         if (l3.lt.nl) then
	    l3=l3+1 
	 else 
	    l2=l2+1 
	    l3=l2+1
	 endif
         call deltas(delta,tt(i7(l2)),pp(i7(l2)),tt(i7(l3)),pp(i7(l3)))
         if (delta.le.dmx) then
            call trids(ds,dd,tt(i7(l2)),pp(i7(l2)),tt(i7(l3)),
     &		       pp(i7(l3)),ela,elo,tt(i7(l1)),pp(i7(l1)))
            if (dd.gt.ddmn) then 
	       factor = ds/dd 
               if (factor.le.1.) nextnode=.false.
            endif
         endif
      enddo
      i(1) = i7(l1)
      f(1) = factor
      fsum = factor
      
      call trids(ds,dd,tt(i7(l1)),pp(i7(l1)),tt(i7(l3)),pp(i7(l3)),
     &		 ela,elo,tt(i7(l2)),pp(i7(l2)))
      if (dd.lt.2*ddmn) then
          print*, dd,ddmn,i7(l2),180.*ela/pi,180.*elo/pi
      endif
      if (dd.le.ddmn) then
         write(6,*) 'error: dd=0! at second factor, for:',
     &		     180.*ela/pi,180.*elo/pi
         write(6,*) 'point not included'
         nti = 0
         return
      endif
      factor = ds/dd
      if (factor.gt.1.) then 
*         write(6,*) 'error, f>1 at second factor, for:',
*     &		     180.*ela/pi,180.*elo/pi
*         write(6,*) 'point NOT included'
         nti = 0
         return
      endif
      i(2) = i7(l2)
      f(2) = factor
      fsum = fsum + factor
      call trids(ds,dd,tt(i7(l1)),pp(i7(l1)),tt(i7(l2)),pp(i7(l2)),
     &		 ela,elo,tt(i7(l3)),pp(i7(l3)))
      if (dd.lt.2*ddmn) then
          print*, dd,ddmn,i7(l3),180.*ela/pi,180.*elo/pi
      endif
      if (dd.le.ddmn) then
         write(6,*) 'error: dd=0! at third factor, for:',
     &		     180.*ela/pi,180.*elo/pi
         write(6,*) 'point not included'
         nti = 0
         return
      endif
      factor = ds/dd
      if (factor.gt.1.) then 
*         write(6,*) 'error, f>1 at third factor, for:',
*     &	             180.*ela/pi,180.*elo/pi 
*         write(6,*) 'point NOT included'
         nti = 0
         return
      endif
      i(3) = i7(l3)
      f(3) = factor
      fsum = fsum + factor
      
      f(1) = f(1)/fsum
      f(2) = f(2)/fsum
      f(3) = f(3)/fsum

      return
      end

